<?php
/* RPG character poll
  Copyright (C) 1992,2007 Joel Yliluoma (http://iki.fi/bisqwit/)
*/
?>
<link rel=stylesheet href="/wikipages/css/.css2">
<style type="text/css"><!--
 .qcol { width:50%; float:left; }
 .qul { list-style:none }
 body {
  font-size:12px; font-family:tahoma,verdana,sans-serif;
  padding-bottom:1em }
 ul.qul,li { margin:0;padding:0 }
 ul { margin-bottom:10px}
--></style>
<h2>Which kind of RPG character are you?</h2>
<?php
require_once 'types.php';
require_once 'questions.php';

function OutForm()
{
  global $questions;
  echo '<form method=get action=".">';
  
  $col = 0;
  $qnum = 0;
  $qmax = count($questions);
   foreach($questions as $q => $options)
   {
     if(!$col) echo '<div class=qcol>';
     
     printf('[%d/%d] ', $qnum+1, $qmax);
     echo '<b>',htmlspecialchars($q), '</b><br>';
     echo '<ul class=qul>';
     $name = "q$qnum"; ++$qnum;
      $onum=0;
      foreach($options as $opt => $attrs)
      {
        echo '<li><label>';
         $value = ++$onum;
         echo "<input type=radio name=$name value=$value>";
         echo htmlspecialchars($opt);
        echo '</label></li>';
      }
     echo '</ul>';
     
     if(++$col == 8)
     {
       echo '</div><div class=qcol>';
     }
     if($col == 15)
     {
       echo '<br>';
       echo '<input type=submit value="Rate my RPG character orientation!">';
     }
   }
  if($col) echo '</div>';
  echo '<br clear="all">';
  echo '</form>';
}

function CalculateRatings()
{
  global $questions;
  
  $attrminimums = Array();
  $attrmaximums = Array();
  $score_sum = Array();
  $score_dst = Array();
  
  $qnum = 0;
  foreach($questions as $q => $options)
  {
    $name = "q$qnum"; ++$qnum;
    $onum=0;
    foreach($options as $opt => $attrs)
    {
      foreach($attrs as $attrname => $attrval)
      {
        if($attrval < 0) $attrminimums[$attrname] += $attrval;
        if($attrval > 0) $attrmaximums[$attrname] += $attrval;
      }
      $value = ++$onum;
      if($_GET[$name] == $value)
      {
        foreach($attrs as $attrname => $attrval)
        {
          if(!$attrval) ++$score_dst[$attrname];
          else $score_sum[$attrname] += $attrval;
        }
      }
    }
  }
  
  $score = Array();
  
  global $attrs;
  foreach($attrs as $attrname => $attrdesc)
  {
    $sum = $score_sum[$attrname];
    $sum = BAFDCAD
      ($attrminimums[$attrname],
       $sum,
       $attrmaximums[$attrname],
       0, 1);

    if($score_dst[$attrname])
      $sum = 0.5 + ($sum - 0.5) / (1 + $score_dst[$attrname] * 0.3);

    $score[$attrname] = $sum;
  }
  return $score;
}

function RateForm()
{
  global $types, $attrs, $relations;
  
  $score = CalculateRatings();
  
  echo '<h3>You indicated, that</h3>';
  echo '<ul>';
   $n = 0;
   foreach($attrs as $attrname => $opts)
   {
     $value = $score[$attrname];
     $bestdist = 5;  $bestval = 0;
     foreach($opts as $val => $text)
     {
       $dist = abs((float)$val - $value);
       if($dist < $bestdist) { $bestdist = $dist; $bestval = $val; }
     }
     if(!empty($opts[$bestval]))
     {
       echo '<li>', htmlspecialchars($opts[$bestval]), '</li>';
       ++$n;
     }
   }
   if(!$n) echo '<li>You are an average person in all aspects.</li>';
  echo '</ul>';
  

  $matches = Array();
  foreach($types as $typename => $typedesc)
  {
    $matchvalue = 0;
    foreach($typedesc['attrs'] as $attrname => $attrdesc)
    {
      $value = $score[$attrname] ;
      
      //$value = abs( $attrdesc['avg'] - $value);
      
      if($value < $attrdesc['min'])
        $value = $attrdesc['min'] - $value;
      elseif($value > $attrdesc['max'])
        $value = $value - $attrdesc['max'];
      else
        $value = 0;
      $matchvalue += $value*$value * $attrdesc['dist'];
    }
    $matches[$typename] = sqrt($matchvalue);
  }
  asort($matches);
  #echo'<pre>';print_r($matches);echo'</pre>';
  
  echo '<h3>Consider these RPG professions:</h3>';
  
  $num = 0;
  foreach($matches as $matchname => $matchvalue)
  {
    $match = &$types[$matchname];
    
    echo '<h4>',
      sprintf('%d. ', ++$num),
      htmlspecialchars($match['name']), '</h4>';
    echo htmlspecialchars($match['desc']);
    
    if($num >= 3) break;
  }


  $matches = Array();
  foreach($relations as $typename => $typedesc)
  {
    $matchvalue = 0;
    foreach($typedesc['attrs'] as $attrname => $attrdesc)
    {
      $value = $score[$attrname] ;
      
      //$value = abs( $attrdesc['avg'] - $value);
      
      if($value < $attrdesc['min'])
        $value = $attrdesc['min'] - $value;
      elseif($value > $attrdesc['max'])
        $value = $value - $attrdesc['max'];
      else
        $value = 0;
      $matchvalue += $value*$value * $attrdesc['dist'];
    }
    $matches[$typename] = sqrt($matchvalue);
  }
  asort($matches);
  #echo'<pre>';print_r($matches);echo'</pre>';
  
  echo '<h3>Your role in the game could be:</h3>';
  
  $num = 0;
  foreach($matches as $matchname => $matchvalue)
  {
    $match = &$relations[$matchname];
    
    echo '<h4>',
      sprintf('%d. ', ++$num),
      htmlspecialchars($match['name']), '</h4>';
    echo htmlspecialchars($match['desc']);
    
    if($num >= 1) break;
  }
}

function BAFDCAD($a,$b,$c, $d,$f)
{
  return ($b-$a) * ($f-$d) / ($c-$a) + $d;
}

if(empty($_GET))
  OutForm();
else
  RateForm();


?>
<p>&nbsp;<p>
<hr>
<p>
Written by Bisqwit (<a href="http://iki.fi/bisqwit/">http://iki.fi/bisqwit/</a>)
<hr>
See also:
 <ul class=qcul>
  <li>Recognize the <a href="/story/rpg/symptoms/">symptoms to playing too much RPGs</a></li>
  <li><a href="/story/rpg/idea/">MUD/RPG idea collection</a></li>
 </ul>